<script setup lang="ts">
import { computed, watchPostEffect, inject } from "vue";

import MeSHTreeNodeComponent from "./MeSHTreeNodeComponent.vue";
import injectionSymbols from "./injectionSymbols";

import meshDescriptorsTree from "@/data/meshDescriptorsTree";
import meshDescriptorsFlat from "@/data/meshDescriptorsFlat";
import meshDescriptorsPrecalc from "@/data/meshDescriptorsPrecalc";

import type { MeSHTreeRoot, MeSHUI } from "@/types/mesh";

export interface Props {
  tree?: MeSHTreeRoot;
}

const props = withDefaults(defineProps<Props>(), {
  tree: () => meshDescriptorsTree,
});

const meshDescriptorsSelectedDirectly = inject(
  injectionSymbols.meshDescriptorsSelectedDirectly,
)!;

const meshDescriptorsSelectedTotal = inject(
  injectionSymbols.meshDescriptorsSelectedTotal,
)!;

// Compute the set of UIs that have a descendant that is selected
const hasSelectedDescendants = computed<Set<MeSHUI>>(() => {
  if ("children" in props.tree) {
    // Get list of precalculated ancestors of selected descriptors
    const precalculated = meshDescriptorsSelectedDirectly.value
      .map((i) => meshDescriptorsPrecalc.ancestors[i.ui])
      .flat()
      .filter((i) => i !== undefined);
    return new Set(precalculated);
  }
  return new Set();
});

// Compute the set of UIs that have an ancestor that is selected
const hasSelectedAncestors = computed<Set<MeSHUI>>(() => {
  if ("children" in props.tree) {
    // Get list of precalculated descendants of selected descriptors
    const precalculated = meshDescriptorsSelectedDirectly.value
      .map((i) => meshDescriptorsPrecalc.descendants[i.ui])
      .flat()
      .filter((i) => i !== undefined);
    return new Set(precalculated);
  }
  return new Set();
});

// Emit the selected descriptors
watchPostEffect(() => {
  const directlySelected = meshDescriptorsSelectedDirectly.value.map((i) => ({
    ...meshDescriptorsFlat[i.ui],
    isDescendant: false,
  }));

  const indirectlySelected = Array.from(hasSelectedAncestors.value || []).map(
    (ui) => ({
      ...meshDescriptorsFlat[ui],
      isDescendant: true,
    }),
  );

  meshDescriptorsSelectedTotal.value =
    directlySelected.concat(indirectlySelected);
});
</script>

<template>
  <MeSHTreeNodeComponent
    v-for="[path, child] in Object.entries(props.tree.children)"
    :path="path"
    :key="child.ui"
    :node="child"
    :hasSelectedDescendants="hasSelectedDescendants"
    :hasSelectedAncestors="hasSelectedAncestors"
  />
</template>
